package at.ac.tuwien.dbai.ges.solver;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;

/**
 * Handles XML reading and writing.
 *
 * @author Lucas Kletzander
 */
public class MarshallingUtil {

    public static <T> T readFromFile(String fileName, Class<T> clazz) throws IOException {
       return readFromFile(new File(fileName), clazz);
    }

    public static <T> T readFromFile(File file, Class<T> clazz) throws IOException {

        try {
            return clazz.cast(JAXBContext.newInstance(clazz).createUnmarshaller().unmarshal(file));
        } catch (JAXBException e) {
            throw new IOException(e);
        }

    }

    public static void printToFile(String fileName, Object content) throws IOException {

        try {

            StringWriter writer = new StringWriter();
            JAXBContext context = JAXBContext.newInstance(content.getClass());
            Marshaller marshaller = context.createMarshaller();
            marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
            marshaller.marshal(content, writer);

            PrintWriter print = new PrintWriter(fileName);
            print.print(writer.toString());
            print.close();

        } catch (JAXBException e) {
            throw new IOException(e);
        }

    }

}
