package at.ac.tuwien.dbai.ges.solver;

import at.ac.tuwien.dbai.ges.schema.WeightedTimePoint;
import at.ac.tuwien.dbai.ges.solver.converter.DateTimeConverter;

/**
 * Utility functions.
 *
 * @author Lucas Kletzander
 */
public class Util {

    public static int getTimeDifference(int day1, int time1, int day2, int time2) {
        return day2 * 24 * 60 + time2 - day1 * 24 * 60 - time1;
    }

    public static int getTimeAtDay(int day, int time, int targetDay) {
        return (day - targetDay) * 24 * 60 + time;
    }

    public static int updateMin(int previousMin, WeightedTimePoint timePoint) {
        int current = DateTimeConverter.convertTimePoint(timePoint.getValue());
        return timePoint.getWeight() == null ? (previousMin == -1 ? current : Math.min(current, previousMin)) : previousMin;
    }

    public static int updateMax(int previousMax, WeightedTimePoint timePoint) {
        return timePoint.getWeight() == null ? Math.max(DateTimeConverter.convertTimePoint(timePoint.getValue()), previousMax) : previousMax;
    }

}
