package at.ac.tuwien.dbai.ges.solver.algorithm;

import at.ac.tuwien.dbai.ges.solver.definition.Instance;
import at.ac.tuwien.dbai.ges.solver.solution.Solution;

/**
 * This is the base class for any algorithm.
 *
 * @author Lucas Kletzander
 */
public abstract class Algorithm {

    /**
     * Applies the algorithm to an instance and a solution.
     * @param instance The problem instance.
     * @param solution The current solution, might be empty or any partial or full solution.
     */
    public abstract void apply(Instance instance, Solution solution);

}
