package at.ac.tuwien.dbai.ges.solver.algorithm.move.selection;

import at.ac.tuwien.dbai.ges.solver.solution.EmployeeSchedule;
import at.ac.tuwien.dbai.ges.solver.solution.Solution;
import at.ac.tuwien.dbai.ges.solver.solution.TaskInstance;

/**
 * A selection strategy.
 *
 * @author Lucas Kletzander
 */
public interface SelectionStrategy {

    EmployeeSchedule selectEmployee(Solution solution);

    EmployeeSchedule selectEmployeeExcept(Solution solution, EmployeeSchedule except);

    int selectDay(Solution solution);

    int selectDayExcept(Solution solution, int except);

    TaskInstance selectTask(Solution solution);

}
