package at.ac.tuwien.dbai.ges.solver.constraint.breaks;

import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.BreakConstraint;
import at.ac.tuwien.dbai.ges.solver.constraint.weight.WeightStrategy;
import at.ac.tuwien.dbai.ges.solver.definition.Instance;
import at.ac.tuwien.dbai.ges.solver.solution.Break;

import java.util.ArrayList;
import java.util.List;

/**
 * Constrains the end time of a break.
 *
 * @author Lucas Kletzander
 */
public class BreakEndConstraint extends BreakConstraint {

    public List<WeightStrategy<Integer>> weightStrategy = new ArrayList<>();

    public BreakEndConstraint(Instance instance) {
        super(instance);
    }

    @Override
    public void addBreak(Break br) {
        newValue += weightStrategy.stream().mapToDouble(i -> i.evaluate(br.end)).sum();
    }

    @Override
    public void removeBreak(Break br) {
        newValue -= weightStrategy.stream().mapToDouble(i -> i.evaluate(br.end)).sum();
    }

}
