package at.ac.tuwien.dbai.ges.solver.constraint.hierarchy;

import at.ac.tuwien.dbai.ges.solver.definition.Instance;
import at.ac.tuwien.dbai.ges.solver.solution.Break;
import at.ac.tuwien.dbai.ges.solver.solution.Shift;

import java.util.NavigableMap;
import java.util.TreeMap;

/**
 * This constraint type deals with the arrangement of breaks within a shift.
 *
 * @author Lucas Kletzander
 */
public abstract class BreakArrangementConstraint extends Constraint {

    public BreakArrangementConstraint(Instance instance) {
        super(instance);
    }

    public abstract void changeShift(Shift shift, NavigableMap<Integer, Break> breaks, NavigableMap<Integer, Break> replacements);

    public void removeShift(Shift shift) {

        NavigableMap<Integer, Break> replacements = new TreeMap<>();
        shift.breaks.keySet().forEach(i -> replacements.put(i, null));
        changeShift(shift, shift.breaks, replacements);

    }

    public void addShift(Shift shift) {

        changeShift(shift, new TreeMap<>(), shift.breaks);

    }

}
