package at.ac.tuwien.dbai.ges.solver.constraint.shift;

import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.ShiftConstraint;
import at.ac.tuwien.dbai.ges.solver.constraint.weight.WeightStrategy;
import at.ac.tuwien.dbai.ges.solver.definition.Instance;
import at.ac.tuwien.dbai.ges.solver.solution.Shift;

import java.util.List;

/**
 * Constrains the number of assigned employees.
 *
 * @author Lucas Kletzander
 */
public class EmployeeLimitConstraint extends ShiftConstraint {//TODO include start and end day?

    public int count;
    public int newCount;
    public List<WeightStrategy<Integer>> weightStrategy;

    public EmployeeLimitConstraint(Instance instance) {
        super(instance);
    }

    @Override
    public double evaluate() {
        newValue = weightStrategy.stream().mapToDouble(i -> i.evaluate(newCount)).sum();
        return super.evaluate();
    }

    @Override
    public void execute() {
        super.execute();
        count = newCount;
    }

    @Override
    public void abort() {
        super.abort();
        newCount = count;
    }

    @Override
    public void addShift(String id, Shift shift) {
        newCount++;
    }

    @Override
    public void removeShift(String id, Shift shift) {
        newCount--;
    }

}
