package at.ac.tuwien.dbai.ges.solver.constraint.shift;

import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.ShiftConstraint;
import at.ac.tuwien.dbai.ges.solver.constraint.weight.WeightStrategy;
import at.ac.tuwien.dbai.ges.solver.definition.Instance;
import at.ac.tuwien.dbai.ges.solver.solution.Shift;

/**
 * Constrains the length of a shift.
 *
 * @author Lucas Kletzander
 */
public class ShiftLengthConstraint extends ShiftConstraint {

    public WeightStrategy<Integer> strategy;

    public ShiftLengthConstraint(Instance instance) {
        super(instance);
    }

    @Override
    public void addShift(String id, Shift shift) {
        newValue += strategy.evaluate(shift.end - shift.start);
    }

    @Override
    public void removeShift(String id, Shift shift) {
        newValue -= strategy.evaluate(shift.end - shift.start);
    }

}
