package at.ac.tuwien.dbai.ges.solver.constraint.shift;

import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.ShiftConstraint;
import at.ac.tuwien.dbai.ges.solver.constraint.weight.WeightStrategy;
import at.ac.tuwien.dbai.ges.solver.definition.Instance;
import at.ac.tuwien.dbai.ges.solver.solution.Shift;

/**
 * Constrains the start time of a shift.
 *
 * @author Lucas Kletzander
 */
public class ShiftStartConstraint extends ShiftConstraint {

    public WeightStrategy<Integer> strategy;

    public ShiftStartConstraint(Instance instance) {
        super(instance);
    }

    @Override
    public void addShift(String id, Shift shift) {
        newValue += strategy.evaluate(shift.start);
    }

    @Override
    public void removeShift(String id, Shift shift) {
        newValue -= strategy.evaluate(shift.start);
    }

}
