package at.ac.tuwien.dbai.ges.solver.constraint.task;

import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.TaskConstraint;
import at.ac.tuwien.dbai.ges.solver.constraint.weight.WeightStrategy;
import at.ac.tuwien.dbai.ges.solver.definition.Instance;
import at.ac.tuwien.dbai.ges.solver.solution.TaskInstance;

import java.util.ArrayList;
import java.util.List;

/**
 * Constrains the end of a task.
 *
 * @author Lucas Kletzander
 */
public class TaskEndConstraint extends TaskConstraint {

    public List<WeightStrategy<Integer>> weightStrategy = new ArrayList<>();

    public TaskEndConstraint(Instance instance) {
        super(instance);
    }

    @Override
    public void addTask(TaskInstance task) {
        newValue += weightStrategy.stream().mapToDouble(i -> i.evaluate(task.getLast().end)).sum();
    }

    @Override
    public void removeTask(TaskInstance task) {
        newValue -= weightStrategy.stream().mapToDouble(i -> i.evaluate(task.getLast().end)).sum();
    }

    @Override
    public TaskEndConstraint clone() {

        TaskEndConstraint constraint = new TaskEndConstraint(instance);
        constraint.weightStrategy = weightStrategy;
        return constraint;

    }

}
