package at.ac.tuwien.dbai.ges.solver.converter;

import at.ac.tuwien.dbai.ges.schema.SchedulingHorizon;
import at.ac.tuwien.dbai.ges.solver.constraint.weight.HardConstraintWeightProvider;
import at.ac.tuwien.dbai.ges.solver.definition.Instance;
import at.ac.tuwien.dbai.ges.solver.solution.Solution;

/**
 * Contains all data that might be needed by a converter.
 *
 * @author Lucas Kletzander
 */
public class ConversionContext {

    public SchedulingHorizon horizon;
    public Instance instance;
    public Solution solution = new Solution();
    public DateTimeConverter dateTime;
    public WeightConverter weight = new WeightConverter(new HardConstraintWeightProvider());
    public ConverterProvider provider = new ConverterProvider(this);

}
