package at.ac.tuwien.dbai.ges.solver.converter;

import at.ac.tuwien.dbai.ges.solver.definition.ShiftDefinition;

import java.util.HashSet;
import java.util.Set;

/**
 * Contains utility methods for conversion.
 *
 * @author Lucas Kletzander
 */
public class ConverterUtil {

    /**
     * Expands a shift group id to the set of all shifts contained in the group.
     * @param definition The shift definition.
     * @param groupId The group id.
     * @return The set of shifts contained in the group.
     */
    public static Set<String> convertShiftTypes(ShiftDefinition definition, String groupId) {

        return new HashSet<>(definition.shiftGroups.get(groupId));

    }

    /**
     * Converts the work unit to a boolean.
     * @param workUnit The work unit.
     * @return <code>true</code> if work unit is <code>ShiftLength</code>, else <code>false</code>
     */
    public static boolean convertWorkUnit(String workUnit) {
        return workUnit != null && "shiftlength".equals(workUnit.toLowerCase());
    }

}
