package at.ac.tuwien.dbai.ges.solver.converter.constraint;

import at.ac.tuwien.dbai.ges.schema.IdenticalSequence;
import at.ac.tuwien.dbai.ges.solver.constraint.shift.IdenticalSequenceConstraint;
import at.ac.tuwien.dbai.ges.solver.converter.ConversionContext;
import at.ac.tuwien.dbai.ges.solver.converter.ConversionException;
import at.ac.tuwien.dbai.ges.solver.converter.Converter;

/**
 * Converts identical sequence constraints.
 *
 * @author Lucas Kletzander
 */
public class IdenticalSequenceConstraintConverter extends Converter<IdenticalSequence, IdenticalSequenceConstraint> {

    public IdenticalSequenceConstraintConverter(ConversionContext context) {
        super(IdenticalSequence.class, IdenticalSequenceConstraint.class, context);
    }

    @Override
    public void convert(IdenticalSequence source, IdenticalSequenceConstraint target) throws ConversionException {

        target.validDays = context.dateTime.convertDayOptions(source.getDay(), source.getWeekDay(), source.getDays());
        target.weightStrategy = context.weight.convertMinMaxStrategyList(target, source.getMaxOrMin());

    }

}
