package at.ac.tuwien.dbai.ges.solver.converter.constraint;

import at.ac.tuwien.dbai.ges.schema.WeightedTimeSpan;
import at.ac.tuwien.dbai.ges.solver.constraint.shift.LargestWorkloadGapConstraint;
import at.ac.tuwien.dbai.ges.solver.converter.ConversionContext;
import at.ac.tuwien.dbai.ges.solver.converter.ConversionException;
import at.ac.tuwien.dbai.ges.solver.converter.Converter;

/**
 * Converts workload gap constraints.
 *
 * @author Lucas Kletzander
 */
public class LargestWorkloadGapConstraintConverter extends Converter<WeightedTimeSpan, LargestWorkloadGapConstraint> {

    public LargestWorkloadGapConstraintConverter(ConversionContext context) {
        super(WeightedTimeSpan.class, LargestWorkloadGapConstraint.class, context);
    }

    @Override
    public void convert(WeightedTimeSpan source, LargestWorkloadGapConstraint target) throws ConversionException {
        target.weightStrategy = context.weight.convertWeightedTimeSpanInt(target, source, false);
    }

}
