package at.ac.tuwien.dbai.ges.solver.converter.constraint;

import at.ac.tuwien.dbai.ges.schema.WeightedTimeSpan;
import at.ac.tuwien.dbai.ges.solver.constraint.shift.MinRestTimeConstraint;
import at.ac.tuwien.dbai.ges.solver.converter.ConversionContext;
import at.ac.tuwien.dbai.ges.solver.converter.ConversionException;
import at.ac.tuwien.dbai.ges.solver.converter.Converter;

/**
 * Converts min rest time constraints.
 *
 * @author Lucas Kletzander
 */
public class MinRestTimeConverter extends Converter<WeightedTimeSpan, MinRestTimeConstraint> {

    public MinRestTimeConverter(ConversionContext context) {
        super(WeightedTimeSpan.class, MinRestTimeConstraint.class, context);
    }

    @Override
    public void convert(WeightedTimeSpan source, MinRestTimeConstraint target) throws ConversionException {
        target.weightStrategy = context.weight.convertWeightedTimeSpanInt(target, source, true);
    }

}
