package at.ac.tuwien.dbai.ges.solver.converter.constraint;

import at.ac.tuwien.dbai.ges.schema.Contracts;
import at.ac.tuwien.dbai.ges.solver.constraint.shift.ShiftEndTimesConstraint;
import at.ac.tuwien.dbai.ges.solver.converter.*;

/**
 * Converts shift end time constraints.
 *
 * @author Lucas Kletzander
 */
public class ShiftEndTimesConstraintConverter extends Converter<Contracts.Contract.ShiftEndTimes, ShiftEndTimesConstraint> {

    public ShiftEndTimesConstraintConverter(ConversionContext context) {
        super(Contracts.Contract.ShiftEndTimes.class, ShiftEndTimesConstraint.class, context);
    }

    @Override
    public void convert(Contracts.Contract.ShiftEndTimes source, ShiftEndTimesConstraint target) throws ConversionException {

        target.validDays = context.dateTime.convertDayOptions(source.getDay(), source.getWeekDay(), source.getDays());

        if (source.getShiftTypes() != null) {
            target.types = ConverterUtil.convertShiftTypes(context.instance.shiftDefinition, source.getShiftTypes());
        }

        target.weightStrategy = context.weight.convertMinMaxPointStrategyList(target, source.getMinOrMax());

    }

}
