package at.ac.tuwien.dbai.ges.solver.converter.constraint;

import at.ac.tuwien.dbai.ges.schema.GlobalShiftConstraints;
import at.ac.tuwien.dbai.ges.solver.constraint.shift.ShiftInstanceConstraint;
import at.ac.tuwien.dbai.ges.solver.converter.*;

/**
 * Converts shift instance constraints.
 *
 * @author Lucas Kletzander
 */
public class ShiftInstanceConverter extends Converter<GlobalShiftConstraints.ShiftInstances, ShiftInstanceConstraint> {

    public ShiftInstanceConverter(ConversionContext context) {
        super(GlobalShiftConstraints.ShiftInstances.class, ShiftInstanceConstraint.class, context);
    }

    @Override
    public void convert(GlobalShiftConstraints.ShiftInstances source, ShiftInstanceConstraint target) throws ConversionException {

        if (source.getShiftTypes() != null) {
            target.types = ConverterUtil.convertShiftTypes(context.instance.shiftDefinition, source.getShiftTypes());
        }

        target.weightStrategy = context.weight.convertMinMaxStrategyList(target, source.getMinOrMax());

    }

}
