package at.ac.tuwien.dbai.ges.solver.converter.constraint;

import at.ac.tuwien.dbai.ges.schema.Contracts;
import at.ac.tuwien.dbai.ges.solver.constraint.shift.ShiftLengthsConstraint;
import at.ac.tuwien.dbai.ges.solver.converter.*;

/**
 * Converts shift lengths constraints.
 *
 * @author Lucas Kletzander
 */
public class ShiftLengthsConstraintConverter extends Converter<Contracts.Contract.ShiftLengths, ShiftLengthsConstraint> {

    public ShiftLengthsConstraintConverter(ConversionContext context) {
        super(Contracts.Contract.ShiftLengths.class, ShiftLengthsConstraint.class, context);
    }

    @Override
    public void convert(Contracts.Contract.ShiftLengths source, ShiftLengthsConstraint target) throws ConversionException {

        target.validDays = context.dateTime.convertDayOptions(source.getDay(), source.getWeekDay(), source.getDays());

        if (source.getShiftTypes() != null) {
            target.types = ConverterUtil.convertShiftTypes(context.instance.shiftDefinition, source.getShiftTypes());
        }

        target.weightStrategy = context.weight.convertMinMaxSpanStrategyList(target, source.getMinOrMax());
        target.includeBreakTime = ConverterUtil.convertWorkUnit(source.getUnit());

    }

}
