package at.ac.tuwien.dbai.ges.solver.converter.constraint;

import at.ac.tuwien.dbai.ges.schema.AbstractEmployeeType;
import at.ac.tuwien.dbai.ges.solver.constraint.shift.ShiftRequestConstraint;
import at.ac.tuwien.dbai.ges.solver.converter.ConversionContext;
import at.ac.tuwien.dbai.ges.solver.converter.ConversionException;
import at.ac.tuwien.dbai.ges.solver.converter.Converter;
import at.ac.tuwien.dbai.ges.solver.converter.shift.ShiftMatcherConverter;

/**
 * Converts shift on request constraints.
 *
 * @author Lucas Kletzander
 */
public class ShiftOnRequestConverter extends Converter<AbstractEmployeeType.Preferences.ShiftOnRequest, ShiftRequestConstraint> {

    public ShiftOnRequestConverter(ConversionContext context) {
        super(AbstractEmployeeType.Preferences.ShiftOnRequest.class, ShiftRequestConstraint.class, context);
    }

    @Override
    public void convert(AbstractEmployeeType.Preferences.ShiftOnRequest source, ShiftRequestConstraint target) throws ConversionException {

        target.weight = source.getWeight() == null ? Double.NaN : source.getWeight();
        target.validDays = context.dateTime.convertDayOptions(source.getDay(), source.getWeekDay(), source.getDays());
        target.filter = ShiftMatcherConverter.convertMatch(context, null, source.getAnyShift(), null, source.getShiftTypes());
        target.onRequest = true;

    }

}
