package at.ac.tuwien.dbai.ges.solver.converter.constraint;

import at.ac.tuwien.dbai.ges.schema.Contracts;
import at.ac.tuwien.dbai.ges.solver.constraint.shift.ShiftStartTimesConstraint;
import at.ac.tuwien.dbai.ges.solver.converter.*;

/**
 * Converts shift start time constraints.
 *
 * @author Lucas Kletzander
 */
public class ShiftStartTimesConstraintConverter extends Converter<Contracts.Contract.ShiftStartTimes, ShiftStartTimesConstraint> {

    public ShiftStartTimesConstraintConverter(ConversionContext context) {
        super(Contracts.Contract.ShiftStartTimes.class, ShiftStartTimesConstraint.class, context);
    }

    @Override
    public void convert(Contracts.Contract.ShiftStartTimes source, ShiftStartTimesConstraint target) throws ConversionException {

        target.validDays = context.dateTime.convertDayOptions(source.getDay(), source.getWeekDay(), source.getDays());

        if (source.getShiftTypes() != null) {
            target.types = ConverterUtil.convertShiftTypes(context.instance.shiftDefinition, source.getShiftTypes());
        }

        target.weightStrategy = context.weight.convertMinMaxPointStrategyList(target, source.getMinOrMax());

    }

}
