package at.ac.tuwien.dbai.ges.solver.converter.constraint;

import at.ac.tuwien.dbai.ges.schema.WeekendSequenceCount;
import at.ac.tuwien.dbai.ges.solver.constraint.shift.WeekendSequenceConstraint;
import at.ac.tuwien.dbai.ges.solver.converter.ConversionContext;
import at.ac.tuwien.dbai.ges.solver.converter.ConversionException;
import at.ac.tuwien.dbai.ges.solver.converter.Converter;

/**
 * Converts weekend sequence constraints.
 *
 * @author Lucas Kletzander
 */
public class WeekendSequenceConstraintConverter extends Converter<WeekendSequenceCount, WeekendSequenceConstraint> {

    public WeekendSequenceConstraintConverter(ConversionContext context) {
        super(WeekendSequenceCount.class, WeekendSequenceConstraint.class, context);
    }

    @Override
    public void convert(WeekendSequenceCount source, WeekendSequenceConstraint target) throws ConversionException {

        if (source.getStartDay() != null) {
            target.startDay = context.dateTime.convertDateOrDay(source.getStartDay());
        }

        if (source.getEndDay() != null) {
            target.endDay = context.dateTime.convertDateOrDay(source.getEndDay());
        }

        target.weightStrategy = context.weight.convertMinMaxStrategyList(target, source.getMinOrMax());

    }

}
