package at.ac.tuwien.dbai.ges.solver.converter.employee;

import at.ac.tuwien.dbai.ges.schema.Skills;
import at.ac.tuwien.dbai.ges.solver.converter.ConversionContext;
import at.ac.tuwien.dbai.ges.solver.converter.ConversionException;
import at.ac.tuwien.dbai.ges.solver.converter.Converter;
import at.ac.tuwien.dbai.ges.solver.definition.SkillDefinition;

import java.util.ArrayList;
import java.util.List;

/**
 * Converts skill definitions.
 *
 * @author Lucas Kletzander
 */
public class SkillConverter extends Converter<Skills, SkillDefinition> {

    public SkillConverter(ConversionContext context) {
        super(Skills.class, SkillDefinition.class, context);
    }

    @Override
    public void convert(Skills source, SkillDefinition target) throws ConversionException {

        for (Skills.Skill skill : source.getSkill()) {

            List<SkillDefinition.Included> included = new ArrayList<>();

            for (Skills.Skill.IncludesSkill inc : skill.getIncludesSkill()) {
                included.add(new SkillDefinition.Included(inc.getValue(), inc.getWeight()));
            }

            target.skills.put(skill.getID(), included);

        }

    }

}
