package at.ac.tuwien.dbai.ges.solver.definition;

import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.ShiftArrangementConstraint;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Base class for employees.
 *
 * @author Lucas Kletzander
 */
public abstract class AbstractEmployee {

    public String id;
    public Set<String> contracts = new HashSet<>();
    public List<ShiftArrangementConstraint> preferences = new ArrayList<>();
    public Set<String> skills = new HashSet<>();//TODO skill penalty

    public void updateSkillCache(ContractDefinition contractDefinition) {

        skills.clear();
        contracts.forEach(i -> skills.addAll(contractDefinition.contracts.get(i).skills.keySet()));

    }

}
