package at.ac.tuwien.dbai.ges.solver.definition;

import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.Constraint;
import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.ShiftArrangementConstraint;
import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.ShiftConstraint;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import java.util.stream.Stream;

/**
 * Contains all contracts and provides access to their constraints.
 *
 * @author Lucas Kletzander
 */
public class ContractDefinition {

    public Map<String, Contract> contracts = new HashMap<>();

    public Stream<ShiftConstraint> getShiftConstraints(Set<String> set) {
        return set.stream().flatMap(i -> contracts.get(i).shiftConstraints.stream());
    }

    public Stream<ShiftArrangementConstraint> getShiftArrangementConstraints(Set<String> set) {
        return set.stream().flatMap(i -> contracts.get(i).arrangementConstraints.stream());
    }

    public Stream<Constraint> getConstraints() {
        return contracts.values().stream().flatMap(i -> Stream.concat(i.arrangementConstraints.stream(), i.shiftConstraints.stream()));
    }

}
