package at.ac.tuwien.dbai.ges.solver.demand;

import at.ac.tuwien.dbai.ges.solver.constraint.shift.ShiftRequirementConstraint;

import java.util.HashMap;
import java.util.Map;

/**
 * A shift demand.
 *
 * @author Lucas Kletzander
 */
public class ShiftDemand implements Cloneable {

    public String id;
    public String shift;
    public ShiftRequirementConstraint requirement;
    public Map<String, ShiftRequirementConstraint> skillConstraints = new HashMap<>();

    @Override
    public ShiftDemand clone() {

        ShiftDemand demand = new ShiftDemand();
        demand.id = id;
        demand.shift = shift;

        if (requirement != null) {
            demand.requirement = requirement.clone();
        }

        for (Map.Entry<String, ShiftRequirementConstraint> entry : skillConstraints.entrySet()) {
            demand.skillConstraints.put(entry.getKey(), entry.getValue().clone());
        }

        return demand;

    }

}
