package at.ac.tuwien.dbai.ges.solver.demand;

import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.Constraint;
import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.ShiftConstraint;

import java.util.*;
import java.util.stream.IntStream;
import java.util.stream.Stream;

/**
 * Contains all shift demands.
 *
 * @author Lucas Kletzander
 */
public class ShiftDemands {

    public List<Map<String, ShiftDemand>> demand;

    public ShiftDemands(int days) {

        demand = new ArrayList<>();
        IntStream.range(0, days).forEach(i -> demand.add(new HashMap<>()));

    }

    public Stream<ShiftConstraint> getShiftConstraints(String type, int day, Set<String> skills) {//TODO skill penalties

        ShiftDemand d = demand.get(day).get(type);
        return d == null ? Stream.empty() : Stream.concat(d.requirement == null ? Stream.empty() : Stream.of(d.requirement),
                        d.skillConstraints.entrySet().stream().filter(k -> skills.contains(k.getKey())).map(Map.Entry::getValue));

    }

    public Stream<Constraint> getConstraints() {

        return demand.stream()
                .flatMap(i -> i.values().stream()
                        .flatMap(j -> Stream.concat(j.requirement == null ? Stream.empty() : Stream.of(j.requirement), j.skillConstraints.values().stream())));

    }

}
