package at.ac.tuwien.dbai.ges.solver.demand;

import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.Constraint;
import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.TaskConstraint;

import java.util.*;
import java.util.stream.IntStream;
import java.util.stream.Stream;

/**
 * Contains all task demands.
 *
 * @author Lucas Kletzander
 */
public class TaskDemands {

    public List<List<TaskDemand>> demand;
    public Map<String, TaskDemand> idMap = new HashMap<>();

    public TaskDemands(int days) {

        demand = new ArrayList<>();
        IntStream.range(0, days + 1).forEach(i -> demand.add(new ArrayList<>()));

    }

    public Stream<TaskConstraint> getTaskConstraints(String id, Set<String> skills) {

        TaskDemand d = idMap.get(id);
        return Stream.concat(d.constraints.stream(),
                d.skillConstraints.entrySet().stream().filter(k -> skills.contains(k.getKey())).map(Map.Entry::getValue));

    }

    public Stream<Constraint> getConstraints() {
        return demand.stream().flatMap(i -> i.stream().flatMap(j -> Stream.concat(j.constraints.stream(), j.skillConstraints.values().stream())));
    }

}
