package at.ac.tuwien.dbai.ges.solver.solution;

import at.ac.tuwien.dbai.ges.solver.constraint.solver.OverlapConstraint;

import java.util.HashSet;
import java.util.NavigableMap;
import java.util.Set;
import java.util.TreeMap;

/**
 * The schedule for a specific employee.
 *
 * @author Lucas Kletzander
 */
public class EmployeeSchedule {

    public String id;//TODO generated id for variable employees
    public Shift[] shifts;
    public boolean[] fixed;
    public OverlapConstraint overlap;
    public NavigableMap<Integer, Set<String>> taskIndex = new TreeMap<>();

    public EmployeeSchedule(String id, int days, OverlapConstraint overlap) {

        this.id = id;
        shifts = new Shift[days];
        fixed = new boolean[days];
        this.overlap = overlap;

    }

    public Set<String> getTasksAt(TaskInstance instance) {
        return taskIndex.computeIfAbsent(instance.day * 24 * 60 + instance.getFirst().start, k -> new HashSet<>());
    }

}
