package at.ac.tuwien.dbai.ges.solver.solution;

import at.ac.tuwien.dbai.ges.solver.constraint.hierarchy.Constraint;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.stream.Stream;

/**
 * A solution including the schedule, different ways to access parts of the schedule and access to the overlap constraint.
 *
 * @author Lucas Kletzander
 */
public class Solution {

    public double value;
    public Map<String, EmployeeSchedule> schedule = new HashMap<>();
    public ArrayList<EmployeeSchedule> scheduleList = new ArrayList<>();
    public Map<String, TaskInstance> taskInstances = new HashMap<>();
    public ArrayList<TaskInstance> taskList = new ArrayList<>();

    public void addEmployeeSchedule(EmployeeSchedule s) {
        schedule.put(s.id, s);
        scheduleList.add(s);
    }

    public void addTaskInstance(TaskInstance inst) {
        taskInstances.put(inst.demandId, inst);
        taskList.add(inst);
    }

    public Stream<Constraint> getConstraintStream() {
        return schedule.values().stream().map(i -> i.overlap);
    }

}
