package at.ac.tuwien.dbai.ges.solver.solution;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * A task instance representing the assignment of one task demand to a specific employee at a specific time.
 *
 * @author Lucas Kletzander
 */
public class TaskInstance {

    public final String demandId;
    public int day;
    public Set<String> employees = new HashSet<>();
    public List<Task> parts = new ArrayList<>();

    public TaskInstance(String demandId, int day) {
        this.demandId = demandId;
        this.day = day;
    }

    public Task getFirst() {
        return parts.get(0);
    }

    public Task getLast() {
        return parts.get(parts.size() - 1);
    }

}
